﻿Public Class VAPlugin_VB

    'NOTE THAT THIS IS A SAMPLE CLASS AND IS NOT FOR ANY MEANINGFUL USE.
    'You will want to gut this completely if you plan on using it... lol

    Public Shared Function VA_DisplayName() As String
        Return "My VoiceAttack VB Plugin v1.5.9+"
    End Function

    Public Shared Function VA_Id() As Guid
        Return New Guid("{65183525-4D75-40eb-84D4-2CB698D713DB}")  'this id must be generated by YOU... it must be unique so VoiceAttack can identify and use the plugin
    End Function

    Public Shared Function VA_DisplayInfo() As String
        Return "My VoiceAttack Plugin\r\n\r\nThis is just a sample.\r\n\r\n2015 VoiceAttack"  'this is just extended info that you might want to give to the user.  note that you should format this up properly.
    End Function

    Public Shared Sub VA_Init1(ByRef state As Dictionary(Of String, Object), ByRef smallIntValues As Dictionary(Of String, Int16?), ByRef textValues As Dictionary(Of String, String), ByRef intValues As Dictionary(Of String, Integer?), ByRef decimalValues As Dictionary(Of String, Decimal?), ByRef booleanValues As Dictionary(Of String, Boolean?), ByRef dateTimeValues As Dictionary(Of String, DateTime?), ByRef extendedValues As Dictionary(Of String, Object))

        'this is where you can set up whatever session information that you need.  this will only be called once on voiceattack load, and it is called asynchronously.
        'the state parameter is a local copy of the state held on to by VoiceAttack.  In this case, the state will be a dictionary with zero items.  You can add as many items to hold on to as you want.
        'the smallIntValues (formerly, 'conditions'), textValues, intValues, decimalValues and booleanValues will also be empty.  You can add whatever you want to those lists and VoiceAttack will copy the values into its own lists
        'extendedValues is for future use and will be null.  at the current time, anything you cadd to it will not be used.

        state.Add("stateValue1", "some value here that I might need")  'add whatever private state information you want to maintain
        state.Add("stateValue2", 444)
        state.Add("currentDate", DateTime.Now)

        smallIntValues.Add("initializedSmallInt1", 1)  'add some meaningless example small integers
        smallIntValues.Add("initializedSmallInt2", 2)

        textValues.Add("initializedVBText1", "This is Vee Bee 1")  'add some meaningless example text values
        textValues.Add("initializedVBText2", "This is Vee Bee 2")
    End Sub

    Public Shared Sub VA_Exit1(ByRef state As Dictionary(Of String, Object))

        'this function gets called when VoiceAttack is closing (normally).  You would put your cleanup code in here, but be aware that your code must be robust enough to not absolutely depend on this function being called
        If (state.ContainsKey("myStateValue")) Then
            'do some kind of file cleanup or whatever at this point
        End If
    End Sub

    Public Shared Sub VA_Invoke1(context As String, ByRef state As Dictionary(Of String, Object), ByRef smallIntValues As Dictionary(Of String, Int16?), ByRef textValues As Dictionary(Of String, String), ByRef intValues As Dictionary(Of String, Integer?), ByRef decimalValues As Dictionary(Of String, Decimal?), ByRef booleanValues As Dictionary(Of String, Boolean?), ByRef dateTimeValues As Dictionary(Of String, DateTime?), ByRef extendedValues As Dictionary(Of String, Object))

        'This function is where you will do all of your work.  When VoiceAttack encounters an, 'Execute External Plugin Function' action, the plugin indicated will be called.

        'What you are getting in this function as parameters :

        'context - a string that can be anything you want it to be.  this is passed in from the command action.  this was added to allow you to just pass a value into the plugin in a simple fashion (without having to set small integer/text values beforehand).  Convert the string to whatever type you need to.

        'six dictionaries which are all local copies :
        'state - all values from the state maintained by VoiceAttack for this plugin.  the state allows you to maintain kind of a, 'session' within VoiceAttack.  this value is not persisted to disk and will be erased on restart. other plugins do not have access to this state (private to the plugin)
        'smallIntValues - the small integer variables (formerly, 'conditions') that were specified in the, 'Execute External' command action.
        'textValues - the text variables that were specified in the, 'Execute External' command action.
        'intValues - the integer variables that were specified in the, 'Execute External' command action.
        'decimalValues - the decimal variables that were specified in the, 'Execute External' command action.
        'booleanValues - the boolean variables that were specified in the, 'Execute External' command action.
        'dateTimeValues - the date/time variables that were specified in the, 'Execute External' command action.
        '(you also get, 'extendedValues', but, that will be null because it is for future use)

        'the small integer/text/integer/decimal/date time/boolean variable dictionaries can be manipulated as follows :
        'items can be updated
        'items can be added to the dictionary
        'to indicate to VoiceAttack that you want to remove an item from the each dictionary, set its value to null (a process is already in place to remove items that are null for cleanup purposes, so, we can just use that)
        'any updated values will be reflected back to existing VoiceAttack internal values.
        'any added values will be added to the VoiceAttack internal values.

        'the state dictionary is the complete state.  you can manipulate it however you want, the whole thing will be copied back and replace what VoiceAttack is holding on to

        'if the, 'Execute External Plugin Function' command action has the, 'wait for return' flag set, VoiceAttack will wait until this function completes so that you may check variable values and
        'have VoiceAttack react accordingly.  otherwise, VoiceAttack fires and forgets and doesn't hang out for extra processing.


        'below is just some sample code showing how to work with dicitionaries...  in case you're not familiar with them.  just wouldn't feel complete unless i included it for some reason :)

        'here we test to see if the dictionary contains a certain key.  checking for the key first is important to avoid errors.  you can do this when setting a value and, 'TryGetValue' when you are retrieving values

        If (textValues.ContainsKey("myVBTestValue")) Then 'was the text value passed in?
            If (String.IsNullOrEmpty(textValues("myVBTestValue"))) Then 'if the value is null, set the value to, 'this is new'
                textValues("myVBTestValue") = "this is new"
            Else
                textValues("myVBTestValue") = "hello vee bee " & New Random().Next(1, 6).ToString() 'if the value is not null, this is a subsequent call... just change up the value to nonsense.  this value will go back to VoiceAttack (perhaps to be read with TTS or whatever)
            End If

        Else 'value was not passed in
            textValues.Add("myVBTestValue", "this is new")  'since the value was not passed in, we go ahead and add it to the dictionary.  this will get passed back to VoiceAttack for processing on return
            If (smallIntValues.ContainsKey("someValueIWantToClear")) Then 'looking for a small integer named, 'someValueIWantToClear'
                smallIntValues("someValueIWantToClear") = Nothing  'the item was found... set it to null so it will be removed from the collection on return
            Else
                smallIntValues.Add("someValueIWantToClear", Nothing)  'this is in case the value was not passed in, but you want to clear the value (if it exists in VoiceAttack's list) on return

                'here we are adding some stuff to state
                Dim objValue As Object = Nothing
                Dim strStateValue As String = Nothing
                If (state.TryGetValue("myStateValue", objValue)) Then  'we check to see if there is a value in state for 'myStateValue'
                    strStateValue = objValue 'if we find something, we are going to cast it as a string and use it somewhere in here...
                Else
                    strStateValue = "initialized"  'nothing was found in state... just set the string to, 'initialized' and keep moving...
                End If
            End If
        End If

        'hope that helps some!

    End Sub

End Class
